/*
 ============================================================================
 Name        : ContaVocali.c
 Author      : nome
 Version     :
 Copyright   : sistemi operativi
 Description : Hello World in C, Ansi-style
 ============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <ourhdr.h>


#define FIGLI 5
#define PIPEIN 0
#define PIPEOUT 1

char vocali[] = {'a', 'e', 'i', 'o', 'u'};
int fd_file;
int fd_pipe[FIGLI][2];

void worker(int n);
void contaVocale(char vocale, int pipein, int pipeout);

int main(int argc, char * argv[]) {

	int pid, nread;
	char carattere;

	fd_file = open(argv[1], O_RDONLY);
	if(fd_file < 0) {
		err_sys("Errore nella open");
	}


	if(pipe(fd_pipe[0]) < 0) {
		err_sys("Pipe error");
	}

	if((pid = fork()) < 0) {/* fork error */
		err_sys("Fork error");
	}
	else if(pid > 0) { /* padre */
		close(fd_pipe[0][PIPEIN]); /* descrittore per input */

		while( (nread = read(fd_file, &carattere, sizeof(char))) > 0) {
			if(write(fd_pipe[0][PIPEOUT], &carattere, sizeof(carattere))<0) {
				err_sys("Errore mentre scrivo char nella pipe");
			}
		}
		if(nread < 0) {
			close(fd_file);
			err_sys("Errore nella lettura da file");
		}
		close(fd_pipe[0][PIPEOUT]);  /* chiudo la pipe al primo figlio*/
		close(fd_file);

		wait(NULL); /* aspetto il figlio */

	} else {
		/* figlio A */
		worker(0);

	}

	return EXIT_SUCCESS;
}

void worker(int n) {
	int pid;
	/* figlio */
	close(fd_pipe[n][PIPEOUT]); /* chiudo il descrittore per output */

	if(n == sizeof(vocali)-1) { /* sono alla 'u' */
		contaVocale(vocali[n], fd_pipe[n][PIPEIN], -1);
		exit(0);
	} else {
		if(pipe(fd_pipe[n+1]) < 0) {
			err_sys("Pipe error");
		}

		if((pid = fork()) < 0) {/* fork error */
			err_sys("Fork error");
		}
		else if(pid > 0) { /* padre */
			close(fd_pipe[n+1][PIPEIN]); /* descrittore per input */

			contaVocale(vocali[n], fd_pipe[n][PIPEIN], fd_pipe[n+1][PIPEOUT]);

		} else { /* figlio */
				worker(n+1);
		}
	}

}

void contaVocale(char vocale, int pipein, int pipeout) {
	int nread, count;
	char buffer;

	count = 0;
	while((nread = read(pipein, &buffer, sizeof(char))) > 0) {
		if(buffer == vocale)
			count++;
		if(pipeout > 0)
			if(write(pipeout, &buffer, sizeof(char)) < 0)
				err_sys("Write error");
	}
	if(nread < 0) {
		err_sys("Errore di lettura");
	} else {
		close(pipeout);
	}

	printf("%c presente %d volte\n", vocale, count);

	wait(NULL); /* aspetto terminazione figlio */
	exit(0);
}


